/* tslint:disable */
/* eslint-disable */

type AnimationCallbackJs = (renderer_data: RendererData) => void;



type AttributeCreateCallbackJs = (attribute_create_context: AttributeCreateContext) => void;



type BufferCreateCallbackJs = (buffer_create_context: BufferCreateContext) => WebGLBuffer;



type FramebufferCreateCallbackJs = (ctx: FramebufferCreateContext) => WebGLFramebuffer;



type GetContextCallbackJs = (canvas: HTMLCanvasElement) => WebGL2RenderingContext;



type RenderCallbackJs = (renderer_data: RendererData) => void;



type TextureCreateCallbackJs = (canvas: TextureCreateContext) => WebGLTexture;



type AttributeMap = Map<string, Attribute>;



type BufferMap = Map<string, Buffer>;



type StringArray = string[];



type TextureJsArray = Texture[];



type TextureMap = Map<string, Texture>;



type UniformLocationsMap = Map<string, WebGLUniformLocation>;



type UniformMap = Map<string, Uniform>;



type WebGlProgramMap = Map<string, WebGLShader>;



type WebGlShaderMap = Map<string, WebGLShader>;



type UniformCreateUpdateCallbackJs = (ctx: UniformContext) => void;



type UniformShouldUpdateCallbackJs = (ctx: UniformContext) => boolean;


/**
*/
export class Attribute {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {StringArray}
*/
  VAOIds(): StringArray;
/**
* @returns {string}
*/
  bufferId(): string;
/**
* @returns {WebGLBuffer}
*/
  webglBuffer(): WebGLBuffer;
/**
* @returns {AttributeLocation}
*/
  attributeLocation(): AttributeLocation;
}
/**
*/
export class AttributeCreateContext {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {WebGL2RenderingContext}
*/
  gl(): WebGL2RenderingContext;
/**
* @returns {number}
*/
  now(): number;
/**
* @returns {WebGLBuffer}
*/
  webglBuffer(): WebGLBuffer;
/**
* @returns {AttributeLocation}
*/
  attributeLocation(): AttributeLocation;
}
/**
*/
export class AttributeLink {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {StringArray} vao_ids
* @param {string} buffer_id
* @param {string} attribute_id
* @param {AttributeCreateCallbackJs} attribute_create_callback
*/
  constructor(vao_ids: StringArray, buffer_id: string, attribute_id: string, attribute_create_callback: AttributeCreateCallbackJs);
/**
* @returns {StringArray}
*/
  VAOIds(): StringArray;
/**
* @returns {string}
*/
  bufferId(): string;
/**
* @returns {string}
*/
  attributeId(): string;
/**
* @returns {AttributeCreateCallbackJs | undefined}
*/
  createCallback(): AttributeCreateCallbackJs | undefined;
/**
* @param {WebGL2RenderingContext} gl
* @param {number} now
* @param {WebGLBuffer} webgl_buffer
* @param {AttributeLocation} attribute_location
*/
  createAttribute(gl: WebGL2RenderingContext, now: number, webgl_buffer: WebGLBuffer, attribute_location: AttributeLocation): void;
}
/**
* Wrapper around the raw number returned from WebGL to represent an attribute location
*/
export class AttributeLocation {
  free(): void;
/**
* @returns {number}
*/
  get(): number;
}
/**
*/
export class Buffer {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {string}
*/
  bufferId(): string;
/**
* @returns {WebGLBuffer}
*/
  webglBuffer(): WebGLBuffer;
}
/**
*/
export class BufferCreateContext {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {WebGL2RenderingContext}
*/
  gl(): WebGL2RenderingContext;
/**
* @returns {number}
*/
  now(): number;
}
/**
*/
export class BufferLink {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {string} buffer_id
* @param {BufferCreateCallbackJs} buffer_create_callback
*/
  constructor(buffer_id: string, buffer_create_callback: BufferCreateCallbackJs);
/**
* @returns {string}
*/
  bufferId(): string;
/**
* @param {WebGL2RenderingContext} gl
* @param {number} now
* @returns {WebGLBuffer}
*/
  createBuffer(gl: WebGL2RenderingContext, now: number): WebGLBuffer;
}
/**
*/
export class Framebuffer {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {string}
*/
  framebufferId(): string;
/**
* @returns {WebGLFramebuffer}
*/
  webglFramebuffer(): WebGLFramebuffer;
}
/**
*/
export class FramebufferCreateContext {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {WebGL2RenderingContext} gl
* @param {number} now
* @param {WebGLTexture | undefined} webgl_texture
*/
  constructor(gl: WebGL2RenderingContext, now: number, webgl_texture?: WebGLTexture);
/**
* @returns {WebGL2RenderingContext}
*/
  gl(): WebGL2RenderingContext;
/**
* @returns {number}
*/
  now(): number;
/**
* @returns {WebGLTexture | undefined}
*/
  webglTexture(): WebGLTexture | undefined;
}
/**
*/
export class FramebufferLink {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {string} framebuffer_id
* @param {FramebufferCreateCallbackJs} framebuffer_create_callback
* @param {string | undefined} texture_id
*/
  constructor(framebuffer_id: string, framebuffer_create_callback: FramebufferCreateCallbackJs, texture_id?: string);
/**
* @returns {string}
*/
  framebufferId(): string;
/**
* @returns {string | undefined}
*/
  textureId(): string | undefined;
/**
* @param {WebGL2RenderingContext} gl
* @param {number} now
* @param {WebGLTexture | undefined} texture
* @returns {WebGLFramebuffer}
*/
  createFramebuffer(gl: WebGL2RenderingContext, now: number, texture?: WebGLTexture): WebGLFramebuffer;
}
/**
* Default ID that can be used when no id has been specified by the consuming application
*/
export class IdDefault {
  free(): void;
}
/**
*/
export class ProgramLink {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {string} program_id
* @param {string} vertex_shader_id
* @param {string} fragment_shader_id
*/
  constructor(program_id: string, vertex_shader_id: string, fragment_shader_id: string);
/**
* @returns {string}
*/
  programId(): string;
/**
* @returns {string}
*/
  vertexShaderId(): string;
/**
* @returns {string}
*/
  fragmentShaderId(): string;
/**
* @returns {StringArray}
*/
  transformFeedbackVaryings(): StringArray;
/**
* @returns {ProgramLinkBuilder}
*/
  static builder(): ProgramLinkBuilder;
}
/**
*/
export class ProgramLinkBuilder {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {ProgramLinkBuilder}
*/
  static default(): ProgramLinkBuilder;
/**
*/
  constructor();
/**
* @param {string} program_id
*/
  setProgramId(program_id: string): void;
/**
* @param {string} vertex_shader_id
*/
  setVertexShaderId(vertex_shader_id: string): void;
/**
* @param {string} fragment_shader_id
*/
  setFragmentShaderId(fragment_shader_id: string): void;
/**
* @param {StringArray} transform_feedback_varyings
*/
  setTransformFeedbackVaryings(transform_feedback_varyings: StringArray): void;
/**
* @returns {ProgramLink}
*/
  build(): ProgramLink;
}
/**
*/
export class Renderer {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
*/
  initializeRecorder(): void;
/**
*/
  startAnimating(): void;
/**
*/
  stopAnimating(): void;
/**
* @param {AnimationCallbackJs | undefined} animation_callback
*/
  setAnimationCallback(animation_callback?: AnimationCallbackJs): void;
/**
*/
  startRecording(): void;
/**
*/
  stopRecording(): void;
/**
*/
  clearRecordedData(): void;
/**
* @returns {boolean}
*/
  recorderInitialized(): boolean;
/**
* @returns {boolean}
*/
  isAnimating(): boolean;
/**
* @returns {boolean}
*/
  isRecording(): boolean;
/**
* @returns {RendererData}
*/
  rendererData(): RendererData;
/**
* @returns {RendererDataBuilder}
*/
  static builder(): RendererDataBuilder;
/**
* @returns {HTMLCanvasElement}
*/
  canvas(): HTMLCanvasElement;
/**
* @returns {WebGL2RenderingContext}
*/
  gl(): WebGL2RenderingContext;
/**
* @param {string} fragment_shader_id
* @returns {WebGLShader | undefined}
*/
  fragmentShader(fragment_shader_id: string): WebGLShader | undefined;
/**
* @param {string} vertex_shader_id
* @returns {WebGLShader | undefined}
*/
  vertexShader(vertex_shader_id: string): WebGLShader | undefined;
/**
* @param {string} program_id
* @returns {WebGLProgram | undefined}
*/
  program(program_id: string): WebGLProgram | undefined;
/**
* @param {string} uniform_id
* @returns {Uniform | undefined}
*/
  uniform(uniform_id: string): Uniform | undefined;
/**
* @param {string} buffer_id
* @returns {Buffer | undefined}
*/
  buffer(buffer_id: string): Buffer | undefined;
/**
* @param {string} attribute_id
* @returns {Attribute | undefined}
*/
  attribute(attribute_id: string): Attribute | undefined;
/**
* @param {string} texture_id
* @returns {Texture | undefined}
*/
  texture(texture_id: string): Texture | undefined;
/**
* @param {string} framebuffer_id
* @returns {Framebuffer | undefined}
*/
  framebuffer(framebuffer_id: string): Framebuffer | undefined;
/**
* @param {string} transform_feedback_id
* @returns {WebGLTransformFeedback | undefined}
*/
  transformFeedback(transform_feedback_id: string): WebGLTransformFeedback | undefined;
/**
* @param {string} vao_id
* @returns {WebGLVertexArrayObject | undefined}
*/
  vao(vao_id: string): WebGLVertexArrayObject | undefined;
/**
* @returns {object | undefined}
*/
  userCtx(): object | undefined;
/**
* @param {string} program_id
*/
  useProgram(program_id: string): void;
/**
* @param {string} vao_id
*/
  useVAO(vao_id: string): void;
/**
* @param {string} uniform_id
*/
  updateUniform(uniform_id: string): void;
/**
*/
  updateUniforms(): void;
/**
*/
  render(): void;
/**
*/
  saveImage(): void;
/**
* @returns {RenderCallbackJs | undefined}
*/
  renderCallback(): RenderCallbackJs | undefined;
}
/**
*/
export class RendererData {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {RendererDataBuilder}
*/
  static builder(): RendererDataBuilder;
/**
* @returns {HTMLCanvasElement}
*/
  canvas(): HTMLCanvasElement;
/**
* @returns {WebGL2RenderingContext}
*/
  gl(): WebGL2RenderingContext;
/**
* @param {string} fragment_shader_id
* @returns {WebGLShader | undefined}
*/
  fragmentShader(fragment_shader_id: string): WebGLShader | undefined;
/**
* @returns {WebGlShaderMap}
*/
  fragmentShaders(): WebGlShaderMap;
/**
* @param {string} vertex_shader_id
* @returns {WebGLShader | undefined}
*/
  vertexShader(vertex_shader_id: string): WebGLShader | undefined;
/**
* @returns {WebGlShaderMap}
*/
  vertexShaders(): WebGlShaderMap;
/**
* @param {string} program_id
* @returns {WebGLProgram | undefined}
*/
  program(program_id: string): WebGLProgram | undefined;
/**
* @returns {WebGlProgramMap}
*/
  programs(): WebGlProgramMap;
/**
* @param {string} uniform_id
* @returns {Uniform | undefined}
*/
  uniform(uniform_id: string): Uniform | undefined;
/**
* @returns {UniformMap}
*/
  uniforms(): UniformMap;
/**
* @param {string} buffer_id
* @returns {Buffer | undefined}
*/
  buffer(buffer_id: string): Buffer | undefined;
/**
* @returns {BufferMap}
*/
  buffers(): BufferMap;
/**
* @param {string} attribute_id
* @returns {Attribute | undefined}
*/
  attribute(attribute_id: string): Attribute | undefined;
/**
* @returns {AttributeMap}
*/
  attributes(): AttributeMap;
/**
* @param {string} texture_id
* @returns {Texture | undefined}
*/
  texture(texture_id: string): Texture | undefined;
/**
* @returns {TextureMap}
*/
  textures(): TextureMap;
/**
* @param {StringArray} texture_ids
* @returns {TextureJsArray}
*/
  textureById(texture_ids: StringArray): TextureJsArray;
/**
* @param {string} framebuffer_id
* @returns {Framebuffer | undefined}
*/
  framebuffer(framebuffer_id: string): Framebuffer | undefined;
/**
* @param {string} transform_feedback_id
* @returns {WebGLTransformFeedback | undefined}
*/
  transformFeedback(transform_feedback_id: string): WebGLTransformFeedback | undefined;
/**
* @param {string} vao_id
* @returns {WebGLVertexArrayObject | undefined}
*/
  VAO(vao_id: string): WebGLVertexArrayObject | undefined;
/**
* @returns {object | undefined}
*/
  userCtx(): object | undefined;
/**
* @param {string} program_id
*/
  useProgram(program_id: string): void;
/**
* @param {string} vao_id
*/
  useVAO(vao_id: string): void;
/**
* @param {string} uniform_id
*/
  updateUniform(uniform_id: string): void;
/**
*/
  updateUniforms(): void;
/**
*/
  render(): void;
/**
*/
  saveImage(): void;
/**
* @returns {Renderer}
*/
  intoRendererHandle(): Renderer;
}
/**
* See [RendererDataBuilder](crate::RendererDataBuilder)
*/
export class RendererDataBuilder {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {string} texture_id
* @returns {Texture | undefined}
*/
  texture(texture_id: string): Texture | undefined;
/**
* @param {HTMLCanvasElement} canvas
*/
  setCanvas(canvas: HTMLCanvasElement): void;
/**
* @param {string} id
* @param {string} fragment_shader_src
*/
  addFragmentShaderSrc(id: string, fragment_shader_src: string): void;
/**
* @param {string} id
* @param {string} vertex_shader_src
*/
  addVertexShaderSrc(id: string, vertex_shader_src: string): void;
/**
* @param {ProgramLink} program_link
*/
  addProgramLink(program_link: ProgramLink): void;
/**
* @param {RenderCallbackJs} render_callback
*/
  setRenderCallback(render_callback: RenderCallbackJs): void;
/**
* @param {object} ctx
*/
  setUserCtx(ctx: object): void;
/**
* @param {UniformLink} uniform_link
*/
  addUniformLink(uniform_link: UniformLink): void;
/**
* @param {BufferLink} buffer_link
*/
  addBufferLink(buffer_link: BufferLink): void;
/**
* @param {AttributeLink} attribute_link
*/
  addAttributeLink(attribute_link: AttributeLink): void;
/**
* @param {TextureLink} texture_link
*/
  addTextureLink(texture_link: TextureLink): void;
/**
* @param {FramebufferLink} framebuffer_link
*/
  addFramebufferLink(framebuffer_link: FramebufferLink): void;
/**
* @param {TransformFeedbackLink} transform_feedback_link
*/
  addTransformFeedbackLink(transform_feedback_link: TransformFeedbackLink): void;
/**
* @param {string} vertex_array_object_id
*/
  addVAOLink(vertex_array_object_id: string): void;
/**
* @param {Function} get_context_callback
*/
  setGetContextCallback(get_context_callback: Function): void;
/**
* @returns {RendererData}
*/
  buildRendererData(): RendererData;
/**
* @returns {Renderer}
*/
  buildRenderer(): Renderer;
}
/**
*/
export class Texture {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {string}
*/
  textureId(): string;
/**
* @returns {WebGLTexture}
*/
  webglTexture(): WebGLTexture;
}
/**
*/
export class TextureCreateContext {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {WebGL2RenderingContext}
*/
  gl(): WebGL2RenderingContext;
/**
* @returns {number}
*/
  now(): number;
/**
* @returns {HTMLCanvasElement}
*/
  canvas(): HTMLCanvasElement;
}
/**
*/
export class TextureLink {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {string} texture_id
* @param {TextureCreateCallbackJs} create_texture_callback
*/
  constructor(texture_id: string, create_texture_callback: TextureCreateCallbackJs);
/**
* @returns {string}
*/
  textureId(): string;
/**
* @param {WebGL2RenderingContext} gl
* @param {number} now
* @param {HTMLCanvasElement} canvas
* @returns {WebGLTexture}
*/
  createTexture(gl: WebGL2RenderingContext, now: number, canvas: HTMLCanvasElement): WebGLTexture;
}
/**
*/
export class TransformFeedbackLink {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {string} transform_feedback_id
*/
  constructor(transform_feedback_id: string);
/**
* @returns {string}
*/
  transformFeedbackId(): string;
}
/**
*/
export class Uniform {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {StringArray}
*/
  programIds(): StringArray;
/**
* @returns {string}
*/
  uniformId(): string;
/**
* @returns {UniformLocationsMap}
*/
  uniformLocations(): UniformLocationsMap;
}
/**
*/
export class UniformContext {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @returns {WebGL2RenderingContext}
*/
  gl(): WebGL2RenderingContext;
/**
* @returns {number}
*/
  now(): number;
/**
* @returns {WebGLUniformLocation}
*/
  uniformLocation(): WebGLUniformLocation;
}
/**
*/
export class UniformLink {
/**
** Return copy of self without private attributes.
*/
  toJSON(): Object;
/**
* Return stringified version of self.
*/
  toString(): string;
  free(): void;
/**
* @param {StringArray} program_ids
* @param {string} uniform_id
* @param {UniformCreateUpdateCallbackJs} initialize_callback
*/
  constructor(program_ids: StringArray, uniform_id: string, initialize_callback: UniformCreateUpdateCallbackJs);
/**
* @returns {StringArray}
*/
  programIds(): StringArray;
/**
* @returns {string}
*/
  uniformId(): string;
/**
* @returns {UniformCreateUpdateCallbackJs | undefined}
*/
  initializeCallback(): UniformCreateUpdateCallbackJs | undefined;
/**
* @param {UniformCreateUpdateCallbackJs} callback
*/
  setInitializeCallback(callback: UniformCreateUpdateCallbackJs): void;
/**
* @returns {UniformShouldUpdateCallbackJs | undefined}
*/
  shouldUpdateCallback(): UniformShouldUpdateCallbackJs | undefined;
/**
* @param {UniformShouldUpdateCallbackJs} callback
*/
  setShouldUpdateCallback(callback: UniformShouldUpdateCallbackJs): void;
/**
* @param {UniformCreateUpdateCallbackJs} callback
*/
  setUpdateCallback(callback: UniformCreateUpdateCallbackJs): void;
/**
* @returns {UniformCreateUpdateCallbackJs | undefined}
*/
  updateCallback(): UniformCreateUpdateCallbackJs | undefined;
/**
* @returns {boolean}
*/
  useInitCallbackForUpdate(): boolean;
/**
* @param {boolean} use_init_callback_for_update
*/
  setUseInitCallbackForUpdate(use_init_callback_for_update: boolean): void;
}
