import { captureStreamFromCanvas } from './snippets/wrend-c7a7bd5bc07b44c4/src/recording/captureStream.js';
import * as wasm from './wrend_bg.wasm';

const heap = new Array(32).fill(undefined);

heap.push(undefined, null, true, false);

function getObject(idx) { return heap[idx]; }

let heap_next = heap.length;

function dropObject(idx) {
    if (idx < 36) return;
    heap[idx] = heap_next;
    heap_next = idx;
}

function takeObject(idx) {
    const ret = getObject(idx);
    dropObject(idx);
    return ret;
}

function addHeapObject(obj) {
    if (heap_next === heap.length) heap.push(heap.length + 1);
    const idx = heap_next;
    heap_next = heap[idx];

    heap[idx] = obj;
    return idx;
}

const lTextDecoder = typeof TextDecoder === 'undefined' ? (0, module.require)('util').TextDecoder : TextDecoder;

let cachedTextDecoder = new lTextDecoder('utf-8', { ignoreBOM: true, fatal: true });

cachedTextDecoder.decode();

let cachedUint8Memory0 = new Uint8Array();

function getUint8Memory0() {
    if (cachedUint8Memory0.byteLength === 0) {
        cachedUint8Memory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachedUint8Memory0;
}

function getStringFromWasm0(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}

let WASM_VECTOR_LEN = 0;

const lTextEncoder = typeof TextEncoder === 'undefined' ? (0, module.require)('util').TextEncoder : TextEncoder;

let cachedTextEncoder = new lTextEncoder('utf-8');

const encodeString = (typeof cachedTextEncoder.encodeInto === 'function'
    ? function (arg, view) {
    return cachedTextEncoder.encodeInto(arg, view);
}
    : function (arg, view) {
    const buf = cachedTextEncoder.encode(arg);
    view.set(buf);
    return {
        read: arg.length,
        written: buf.length
    };
});

function passStringToWasm0(arg, malloc, realloc) {

    if (realloc === undefined) {
        const buf = cachedTextEncoder.encode(arg);
        const ptr = malloc(buf.length);
        getUint8Memory0().subarray(ptr, ptr + buf.length).set(buf);
        WASM_VECTOR_LEN = buf.length;
        return ptr;
    }

    let len = arg.length;
    let ptr = malloc(len);

    const mem = getUint8Memory0();

    let offset = 0;

    for (; offset < len; offset++) {
        const code = arg.charCodeAt(offset);
        if (code > 0x7F) break;
        mem[ptr + offset] = code;
    }

    if (offset !== len) {
        if (offset !== 0) {
            arg = arg.slice(offset);
        }
        ptr = realloc(ptr, len, len = offset + arg.length * 3);
        const view = getUint8Memory0().subarray(ptr + offset, ptr + len);
        const ret = encodeString(arg, view);

        offset += ret.written;
    }

    WASM_VECTOR_LEN = offset;
    return ptr;
}

function isLikeNone(x) {
    return x === undefined || x === null;
}

let cachedInt32Memory0 = new Int32Array();

function getInt32Memory0() {
    if (cachedInt32Memory0.byteLength === 0) {
        cachedInt32Memory0 = new Int32Array(wasm.memory.buffer);
    }
    return cachedInt32Memory0;
}

function debugString(val) {
    // primitive types
    const type = typeof val;
    if (type == 'number' || type == 'boolean' || val == null) {
        return  `${val}`;
    }
    if (type == 'string') {
        return `"${val}"`;
    }
    if (type == 'symbol') {
        const description = val.description;
        if (description == null) {
            return 'Symbol';
        } else {
            return `Symbol(${description})`;
        }
    }
    if (type == 'function') {
        const name = val.name;
        if (typeof name == 'string' && name.length > 0) {
            return `Function(${name})`;
        } else {
            return 'Function';
        }
    }
    // objects
    if (Array.isArray(val)) {
        const length = val.length;
        let debug = '[';
        if (length > 0) {
            debug += debugString(val[0]);
        }
        for(let i = 1; i < length; i++) {
            debug += ', ' + debugString(val[i]);
        }
        debug += ']';
        return debug;
    }
    // Test for built-in
    const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
    let className;
    if (builtInMatches.length > 1) {
        className = builtInMatches[1];
    } else {
        // Failed to match the standard '[object ClassName]'
        return toString.call(val);
    }
    if (className == 'Object') {
        // we're a user defined class or Object
        // JSON.stringify avoids problems with cycles, and is generally much
        // easier than looping through ownProperties of `val`.
        try {
            return 'Object(' + JSON.stringify(val) + ')';
        } catch (_) {
            return 'Object';
        }
    }
    // errors
    if (val instanceof Error) {
        return `${val.name}: ${val.message}\n${val.stack}`;
    }
    // TODO we could test for more things here, like `Set`s and `Map`s.
    return className;
}

function makeClosure(arg0, arg1, dtor, f) {
    const state = { a: arg0, b: arg1, cnt: 1, dtor };
    const real = (...args) => {
        // First up with a closure we increment the internal reference
        // count. This ensures that the Rust closure environment won't
        // be deallocated while we're invoking it.
        state.cnt++;
        try {
            return f(state.a, state.b, ...args);
        } finally {
            if (--state.cnt === 0) {
                wasm.__wbindgen_export_2.get(state.dtor)(state.a, state.b);
                state.a = 0;

            }
        }
    };
    real.original = state;

    return real;
}
function __wbg_adapter_32(arg0, arg1) {
    wasm._dyn_core__ops__function__Fn_____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h0a8714a16ea4fd06(arg0, arg1);
}

function __wbg_adapter_35(arg0, arg1, arg2) {
    wasm._dyn_core__ops__function__Fn__A____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h2771407c15643d43(arg0, arg1, addHeapObject(arg2));
}

function makeMutClosure(arg0, arg1, dtor, f) {
    const state = { a: arg0, b: arg1, cnt: 1, dtor };
    const real = (...args) => {
        // First up with a closure we increment the internal reference
        // count. This ensures that the Rust closure environment won't
        // be deallocated while we're invoking it.
        state.cnt++;
        const a = state.a;
        state.a = 0;
        try {
            return f(a, state.b, ...args);
        } finally {
            if (--state.cnt === 0) {
                wasm.__wbindgen_export_2.get(state.dtor)(a, state.b);

            } else {
                state.a = a;
            }
        }
    };
    real.original = state;

    return real;
}
function __wbg_adapter_42(arg0, arg1, arg2) {
    wasm._dyn_core__ops__function__FnMut__A____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h53ff2ada8e6cf55a(arg0, arg1, addHeapObject(arg2));
}

function _assertClass(instance, klass) {
    if (!(instance instanceof klass)) {
        throw new Error(`expected instance of ${klass.name}`);
    }
    return instance.ptr;
}

function handleError(f, args) {
    try {
        return f.apply(this, args);
    } catch (e) {
        wasm.__wbindgen_exn_store(addHeapObject(e));
    }
}

function getArrayU8FromWasm0(ptr, len) {
    return getUint8Memory0().subarray(ptr / 1, ptr / 1 + len);
}
/**
*/
export class Attribute {

    static __wrap(ptr) {
        const obj = Object.create(Attribute.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_attribute_free(ptr);
    }
    /**
    * @returns {StringArray}
    */
    VAOIds() {
        const ret = wasm.attribute_VAOIds(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {string}
    */
    bufferId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.attribute_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {WebGLBuffer}
    */
    webglBuffer() {
        const ret = wasm.attribute_webglBuffer(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {AttributeLocation}
    */
    attributeLocation() {
        const ret = wasm.attribute_attributeLocation(this.ptr);
        return AttributeLocation.__wrap(ret);
    }
}
/**
*/
export class AttributeCreateContext {

    static __wrap(ptr) {
        const obj = Object.create(AttributeCreateContext.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_attributecreatecontext_free(ptr);
    }
    /**
    * @returns {WebGL2RenderingContext}
    */
    gl() {
        const ret = wasm.attributecreatecontext_gl(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {number}
    */
    now() {
        const ret = wasm.attributecreatecontext_now(this.ptr);
        return ret;
    }
    /**
    * @returns {WebGLBuffer}
    */
    webglBuffer() {
        const ret = wasm.attributecreatecontext_webglBuffer(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {AttributeLocation}
    */
    attributeLocation() {
        const ret = wasm.attributecreatecontext_attributeLocation(this.ptr);
        return AttributeLocation.__wrap(ret);
    }
}
/**
*/
export class AttributeLink {

    static __wrap(ptr) {
        const obj = Object.create(AttributeLink.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_attributelink_free(ptr);
    }
    /**
    * @param {StringArray} vao_ids
    * @param {string} buffer_id
    * @param {string} attribute_id
    * @param {AttributeCreateCallbackJs} attribute_create_callback
    */
    constructor(vao_ids, buffer_id, attribute_id, attribute_create_callback) {
        const ptr0 = passStringToWasm0(buffer_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ptr1 = passStringToWasm0(attribute_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        const ret = wasm.attributelink_new(addHeapObject(vao_ids), ptr0, len0, ptr1, len1, addHeapObject(attribute_create_callback));
        return AttributeLink.__wrap(ret);
    }
    /**
    * @returns {StringArray}
    */
    VAOIds() {
        const ret = wasm.attributelink_VAOIds(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {string}
    */
    bufferId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.attribute_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {string}
    */
    attributeId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.attributelink_attributeId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {AttributeCreateCallbackJs | undefined}
    */
    createCallback() {
        const ret = wasm.attributelink_createCallback(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {WebGL2RenderingContext} gl
    * @param {number} now
    * @param {WebGLBuffer} webgl_buffer
    * @param {AttributeLocation} attribute_location
    */
    createAttribute(gl, now, webgl_buffer, attribute_location) {
        _assertClass(attribute_location, AttributeLocation);
        var ptr0 = attribute_location.ptr;
        attribute_location.ptr = 0;
        wasm.attributelink_createAttribute(this.ptr, addHeapObject(gl), now, addHeapObject(webgl_buffer), ptr0);
    }
}
/**
* Wrapper around the raw number returned from WebGL to represent an attribute location
*/
export class AttributeLocation {

    static __wrap(ptr) {
        const obj = Object.create(AttributeLocation.prototype);
        obj.ptr = ptr;

        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_attributelocation_free(ptr);
    }
    /**
    * @returns {number}
    */
    get() {
        const ret = wasm.attributelocation_get(this.ptr);
        return ret >>> 0;
    }
}
/**
*/
export class Buffer {

    static __wrap(ptr) {
        const obj = Object.create(Buffer.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_buffer_free(ptr);
    }
    /**
    * @returns {string}
    */
    bufferId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {WebGLBuffer}
    */
    webglBuffer() {
        const ret = wasm.buffer_webglBuffer(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class BufferCreateContext {

    static __wrap(ptr) {
        const obj = Object.create(BufferCreateContext.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_buffercreatecontext_free(ptr);
    }
    /**
    * @returns {WebGL2RenderingContext}
    */
    gl() {
        const ret = wasm.attributecreatecontext_gl(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {number}
    */
    now() {
        const ret = wasm.attributecreatecontext_now(this.ptr);
        return ret;
    }
}
/**
*/
export class BufferLink {

    static __wrap(ptr) {
        const obj = Object.create(BufferLink.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_bufferlink_free(ptr);
    }
    /**
    * @param {string} buffer_id
    * @param {BufferCreateCallbackJs} buffer_create_callback
    */
    constructor(buffer_id, buffer_create_callback) {
        const ptr0 = passStringToWasm0(buffer_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.bufferlink_new(ptr0, len0, addHeapObject(buffer_create_callback));
        return BufferLink.__wrap(ret);
    }
    /**
    * @returns {string}
    */
    bufferId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @param {WebGL2RenderingContext} gl
    * @param {number} now
    * @returns {WebGLBuffer}
    */
    createBuffer(gl, now) {
        const ret = wasm.bufferlink_createBuffer(this.ptr, addHeapObject(gl), now);
        return takeObject(ret);
    }
}
/**
*/
export class Framebuffer {

    static __wrap(ptr) {
        const obj = Object.create(Framebuffer.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_framebuffer_free(ptr);
    }
    /**
    * @returns {string}
    */
    framebufferId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {WebGLFramebuffer}
    */
    webglFramebuffer() {
        const ret = wasm.buffer_webglBuffer(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class FramebufferCreateContext {

    static __wrap(ptr) {
        const obj = Object.create(FramebufferCreateContext.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_framebuffercreatecontext_free(ptr);
    }
    /**
    * @param {WebGL2RenderingContext} gl
    * @param {number} now
    * @param {WebGLTexture | undefined} webgl_texture
    */
    constructor(gl, now, webgl_texture) {
        const ret = wasm.framebuffercreatecontext_new(addHeapObject(gl), now, isLikeNone(webgl_texture) ? 0 : addHeapObject(webgl_texture));
        return FramebufferCreateContext.__wrap(ret);
    }
    /**
    * @returns {WebGL2RenderingContext}
    */
    gl() {
        const ret = wasm.attributecreatecontext_gl(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {number}
    */
    now() {
        const ret = wasm.attributecreatecontext_now(this.ptr);
        return ret;
    }
    /**
    * @returns {WebGLTexture | undefined}
    */
    webglTexture() {
        const ret = wasm.framebuffercreatecontext_webglTexture(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class FramebufferLink {

    static __wrap(ptr) {
        const obj = Object.create(FramebufferLink.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_framebufferlink_free(ptr);
    }
    /**
    * @param {string} framebuffer_id
    * @param {FramebufferCreateCallbackJs} framebuffer_create_callback
    * @param {string | undefined} texture_id
    */
    constructor(framebuffer_id, framebuffer_create_callback, texture_id) {
        const ptr0 = passStringToWasm0(framebuffer_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        var ptr1 = isLikeNone(texture_id) ? 0 : passStringToWasm0(texture_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        const ret = wasm.framebufferlink_new(ptr0, len0, addHeapObject(framebuffer_create_callback), ptr1, len1);
        return FramebufferLink.__wrap(ret);
    }
    /**
    * @returns {string}
    */
    framebufferId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {string | undefined}
    */
    textureId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.framebufferlink_textureId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            let v0;
            if (r0 !== 0) {
                v0 = getStringFromWasm0(r0, r1).slice();
                wasm.__wbindgen_free(r0, r1 * 1);
            }
            return v0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {WebGL2RenderingContext} gl
    * @param {number} now
    * @param {WebGLTexture | undefined} texture
    * @returns {WebGLFramebuffer}
    */
    createFramebuffer(gl, now, texture) {
        const ret = wasm.framebufferlink_createFramebuffer(this.ptr, addHeapObject(gl), now, isLikeNone(texture) ? 0 : addHeapObject(texture));
        return takeObject(ret);
    }
}
/**
* Default ID that can be used when no id has been specified by the consuming application
*/
export class IdDefault {

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_iddefault_free(ptr);
    }
}
/**
*/
export class ProgramLink {

    static __wrap(ptr) {
        const obj = Object.create(ProgramLink.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_programlink_free(ptr);
    }
    /**
    * @param {string} program_id
    * @param {string} vertex_shader_id
    * @param {string} fragment_shader_id
    */
    constructor(program_id, vertex_shader_id, fragment_shader_id) {
        const ptr0 = passStringToWasm0(program_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ptr1 = passStringToWasm0(vertex_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        const ptr2 = passStringToWasm0(fragment_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len2 = WASM_VECTOR_LEN;
        const ret = wasm.programlink_new(ptr0, len0, ptr1, len1, ptr2, len2);
        return ProgramLink.__wrap(ret);
    }
    /**
    * @returns {string}
    */
    programId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {string}
    */
    vertexShaderId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.attribute_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {string}
    */
    fragmentShaderId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.attributelink_attributeId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {StringArray}
    */
    transformFeedbackVaryings() {
        const ret = wasm.programlink_transformFeedbackVaryings(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {ProgramLinkBuilder}
    */
    static builder() {
        const ret = wasm.programlink_builder();
        return ProgramLinkBuilder.__wrap(ret);
    }
}
/**
*/
export class ProgramLinkBuilder {

    static __wrap(ptr) {
        const obj = Object.create(ProgramLinkBuilder.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_programlinkbuilder_free(ptr);
    }
    /**
    * @returns {ProgramLinkBuilder}
    */
    static default() {
        const ret = wasm.programlink_builder();
        return ProgramLinkBuilder.__wrap(ret);
    }
    /**
    */
    constructor() {
        const ret = wasm.programlink_builder();
        return ProgramLinkBuilder.__wrap(ret);
    }
    /**
    * @param {string} program_id
    */
    setProgramId(program_id) {
        const ptr0 = passStringToWasm0(program_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.programlinkbuilder_setProgramId(this.ptr, ptr0, len0);
    }
    /**
    * @param {string} vertex_shader_id
    */
    setVertexShaderId(vertex_shader_id) {
        const ptr0 = passStringToWasm0(vertex_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.programlinkbuilder_setVertexShaderId(this.ptr, ptr0, len0);
    }
    /**
    * @param {string} fragment_shader_id
    */
    setFragmentShaderId(fragment_shader_id) {
        const ptr0 = passStringToWasm0(fragment_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.programlinkbuilder_setFragmentShaderId(this.ptr, ptr0, len0);
    }
    /**
    * @param {StringArray} transform_feedback_varyings
    */
    setTransformFeedbackVaryings(transform_feedback_varyings) {
        wasm.programlinkbuilder_setTransformFeedbackVaryings(this.ptr, addHeapObject(transform_feedback_varyings));
    }
    /**
    * @returns {ProgramLink}
    */
    build() {
        try {
            const ptr = this.__destroy_into_raw();
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.programlinkbuilder_build(retptr, ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            var r2 = getInt32Memory0()[retptr / 4 + 2];
            if (r2) {
                throw takeObject(r1);
            }
            return ProgramLink.__wrap(r0);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
}
/**
*/
export class Renderer {

    static __wrap(ptr) {
        const obj = Object.create(Renderer.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_renderer_free(ptr);
    }
    /**
    */
    initializeRecorder() {
        wasm.renderer_initializeRecorder(this.ptr);
    }
    /**
    */
    startAnimating() {
        wasm.renderer_startAnimating(this.ptr);
    }
    /**
    */
    stopAnimating() {
        wasm.renderer_stopAnimating(this.ptr);
    }
    /**
    * @param {AnimationCallbackJs | undefined} animation_callback
    */
    setAnimationCallback(animation_callback) {
        wasm.renderer_setAnimationCallback(this.ptr, isLikeNone(animation_callback) ? 0 : addHeapObject(animation_callback));
    }
    /**
    */
    startRecording() {
        wasm.renderer_startRecording(this.ptr);
    }
    /**
    */
    stopRecording() {
        wasm.renderer_stopRecording(this.ptr);
    }
    /**
    */
    clearRecordedData() {
        wasm.renderer_clearRecordedData(this.ptr);
    }
    /**
    * @returns {boolean}
    */
    recorderInitialized() {
        const ret = wasm.renderer_recorderInitialized(this.ptr);
        return ret !== 0;
    }
    /**
    * @returns {boolean}
    */
    isAnimating() {
        const ret = wasm.renderer_isAnimating(this.ptr);
        return ret !== 0;
    }
    /**
    * @returns {boolean}
    */
    isRecording() {
        const ret = wasm.renderer_isRecording(this.ptr);
        return ret !== 0;
    }
    /**
    * @returns {RendererData}
    */
    rendererData() {
        const ret = wasm.renderer_rendererData(this.ptr);
        return RendererData.__wrap(ret);
    }
    /**
    * @returns {RendererDataBuilder}
    */
    static builder() {
        const ret = wasm.renderer_builder();
        return RendererDataBuilder.__wrap(ret);
    }
    /**
    * @returns {HTMLCanvasElement}
    */
    canvas() {
        const ret = wasm.renderer_canvas(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {WebGL2RenderingContext}
    */
    gl() {
        const ret = wasm.renderer_gl(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} fragment_shader_id
    * @returns {WebGLShader | undefined}
    */
    fragmentShader(fragment_shader_id) {
        const ptr0 = passStringToWasm0(fragment_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_fragmentShader(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @param {string} vertex_shader_id
    * @returns {WebGLShader | undefined}
    */
    vertexShader(vertex_shader_id) {
        const ptr0 = passStringToWasm0(vertex_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_vertexShader(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @param {string} program_id
    * @returns {WebGLProgram | undefined}
    */
    program(program_id) {
        const ptr0 = passStringToWasm0(program_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_program(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @param {string} uniform_id
    * @returns {Uniform | undefined}
    */
    uniform(uniform_id) {
        const ptr0 = passStringToWasm0(uniform_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_uniform(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Uniform.__wrap(ret);
    }
    /**
    * @param {string} buffer_id
    * @returns {Buffer | undefined}
    */
    buffer(buffer_id) {
        const ptr0 = passStringToWasm0(buffer_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_buffer(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Buffer.__wrap(ret);
    }
    /**
    * @param {string} attribute_id
    * @returns {Attribute | undefined}
    */
    attribute(attribute_id) {
        const ptr0 = passStringToWasm0(attribute_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_attribute(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Attribute.__wrap(ret);
    }
    /**
    * @param {string} texture_id
    * @returns {Texture | undefined}
    */
    texture(texture_id) {
        const ptr0 = passStringToWasm0(texture_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_texture(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Texture.__wrap(ret);
    }
    /**
    * @param {string} framebuffer_id
    * @returns {Framebuffer | undefined}
    */
    framebuffer(framebuffer_id) {
        const ptr0 = passStringToWasm0(framebuffer_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_framebuffer(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Framebuffer.__wrap(ret);
    }
    /**
    * @param {string} transform_feedback_id
    * @returns {WebGLTransformFeedback | undefined}
    */
    transformFeedback(transform_feedback_id) {
        const ptr0 = passStringToWasm0(transform_feedback_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_transformFeedback(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @param {string} vao_id
    * @returns {WebGLVertexArrayObject | undefined}
    */
    vao(vao_id) {
        const ptr0 = passStringToWasm0(vao_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.renderer_vao(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @returns {object | undefined}
    */
    userCtx() {
        const ret = wasm.renderer_userCtx(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} program_id
    */
    useProgram(program_id) {
        const ptr0 = passStringToWasm0(program_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.renderer_useProgram(this.ptr, ptr0, len0);
    }
    /**
    * @param {string} vao_id
    */
    useVAO(vao_id) {
        const ptr0 = passStringToWasm0(vao_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.renderer_useVAO(this.ptr, ptr0, len0);
    }
    /**
    * @param {string} uniform_id
    */
    updateUniform(uniform_id) {
        const ptr0 = passStringToWasm0(uniform_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.renderer_updateUniform(this.ptr, ptr0, len0);
    }
    /**
    */
    updateUniforms() {
        wasm.renderer_updateUniforms(this.ptr);
    }
    /**
    */
    render() {
        wasm.renderer_render(this.ptr);
    }
    /**
    */
    saveImage() {
        wasm.renderer_saveImage(this.ptr);
    }
    /**
    * @returns {RenderCallbackJs | undefined}
    */
    renderCallback() {
        const ret = wasm.renderer_renderCallback(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class RendererData {

    static __wrap(ptr) {
        const obj = Object.create(RendererData.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_rendererdata_free(ptr);
    }
    /**
    * @returns {RendererDataBuilder}
    */
    static builder() {
        const ret = wasm.renderer_builder();
        return RendererDataBuilder.__wrap(ret);
    }
    /**
    * @returns {HTMLCanvasElement}
    */
    canvas() {
        const ret = wasm.rendererdata_canvas(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {WebGL2RenderingContext}
    */
    gl() {
        const ret = wasm.rendererdata_gl(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} fragment_shader_id
    * @returns {WebGLShader | undefined}
    */
    fragmentShader(fragment_shader_id) {
        const ptr0 = passStringToWasm0(fragment_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_fragmentShader(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @returns {WebGlShaderMap}
    */
    fragmentShaders() {
        const ret = wasm.rendererdata_fragmentShaders(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} vertex_shader_id
    * @returns {WebGLShader | undefined}
    */
    vertexShader(vertex_shader_id) {
        const ptr0 = passStringToWasm0(vertex_shader_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_vertexShader(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @returns {WebGlShaderMap}
    */
    vertexShaders() {
        const ret = wasm.rendererdata_vertexShaders(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} program_id
    * @returns {WebGLProgram | undefined}
    */
    program(program_id) {
        const ptr0 = passStringToWasm0(program_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_program(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @returns {WebGlProgramMap}
    */
    programs() {
        const ret = wasm.rendererdata_programs(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} uniform_id
    * @returns {Uniform | undefined}
    */
    uniform(uniform_id) {
        const ptr0 = passStringToWasm0(uniform_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_uniform(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Uniform.__wrap(ret);
    }
    /**
    * @returns {UniformMap}
    */
    uniforms() {
        const ret = wasm.rendererdata_uniforms(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} buffer_id
    * @returns {Buffer | undefined}
    */
    buffer(buffer_id) {
        const ptr0 = passStringToWasm0(buffer_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_buffer(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Buffer.__wrap(ret);
    }
    /**
    * @returns {BufferMap}
    */
    buffers() {
        const ret = wasm.rendererdata_buffers(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} attribute_id
    * @returns {Attribute | undefined}
    */
    attribute(attribute_id) {
        const ptr0 = passStringToWasm0(attribute_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_attribute(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Attribute.__wrap(ret);
    }
    /**
    * @returns {AttributeMap}
    */
    attributes() {
        const ret = wasm.rendererdata_attributes(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} texture_id
    * @returns {Texture | undefined}
    */
    texture(texture_id) {
        const ptr0 = passStringToWasm0(texture_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_texture(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Texture.__wrap(ret);
    }
    /**
    * @returns {TextureMap}
    */
    textures() {
        const ret = wasm.rendererdata_textures(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {StringArray} texture_ids
    * @returns {TextureJsArray}
    */
    textureById(texture_ids) {
        const ret = wasm.rendererdata_textureById(this.ptr, addHeapObject(texture_ids));
        return takeObject(ret);
    }
    /**
    * @param {string} framebuffer_id
    * @returns {Framebuffer | undefined}
    */
    framebuffer(framebuffer_id) {
        const ptr0 = passStringToWasm0(framebuffer_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_framebuffer(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Framebuffer.__wrap(ret);
    }
    /**
    * @param {string} transform_feedback_id
    * @returns {WebGLTransformFeedback | undefined}
    */
    transformFeedback(transform_feedback_id) {
        const ptr0 = passStringToWasm0(transform_feedback_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_transformFeedback(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @param {string} vao_id
    * @returns {WebGLVertexArrayObject | undefined}
    */
    VAO(vao_id) {
        const ptr0 = passStringToWasm0(vao_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdata_VAO(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @returns {object | undefined}
    */
    userCtx() {
        const ret = wasm.rendererdata_userCtx(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {string} program_id
    */
    useProgram(program_id) {
        const ptr0 = passStringToWasm0(program_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.rendererdata_useProgram(this.ptr, ptr0, len0);
    }
    /**
    * @param {string} vao_id
    */
    useVAO(vao_id) {
        const ptr0 = passStringToWasm0(vao_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.rendererdata_useVAO(this.ptr, ptr0, len0);
    }
    /**
    * @param {string} uniform_id
    */
    updateUniform(uniform_id) {
        const ptr0 = passStringToWasm0(uniform_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.rendererdata_updateUniform(this.ptr, ptr0, len0);
    }
    /**
    */
    updateUniforms() {
        wasm.rendererdata_updateUniforms(this.ptr);
    }
    /**
    */
    render() {
        wasm.rendererdata_render(this.ptr);
    }
    /**
    */
    saveImage() {
        wasm.rendererdata_saveImage(this.ptr);
    }
    /**
    * @returns {Renderer}
    */
    intoRendererHandle() {
        const ptr = this.__destroy_into_raw();
        const ret = wasm.rendererdata_intoRendererHandle(ptr);
        return Renderer.__wrap(ret);
    }
}
/**
* See [RendererDataBuilder](crate::RendererDataBuilder)
*/
export class RendererDataBuilder {

    static __wrap(ptr) {
        const obj = Object.create(RendererDataBuilder.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_rendererdatabuilder_free(ptr);
    }
    /**
    * @param {string} texture_id
    * @returns {Texture | undefined}
    */
    texture(texture_id) {
        const ptr0 = passStringToWasm0(texture_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rendererdatabuilder_texture(this.ptr, ptr0, len0);
        return ret === 0 ? undefined : Texture.__wrap(ret);
    }
    /**
    * @param {HTMLCanvasElement} canvas
    */
    setCanvas(canvas) {
        wasm.rendererdatabuilder_setCanvas(this.ptr, addHeapObject(canvas));
    }
    /**
    * @param {string} id
    * @param {string} fragment_shader_src
    */
    addFragmentShaderSrc(id, fragment_shader_src) {
        const ptr0 = passStringToWasm0(id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ptr1 = passStringToWasm0(fragment_shader_src, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        wasm.rendererdatabuilder_addFragmentShaderSrc(this.ptr, ptr0, len0, ptr1, len1);
    }
    /**
    * @param {string} id
    * @param {string} vertex_shader_src
    */
    addVertexShaderSrc(id, vertex_shader_src) {
        const ptr0 = passStringToWasm0(id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ptr1 = passStringToWasm0(vertex_shader_src, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        wasm.rendererdatabuilder_addVertexShaderSrc(this.ptr, ptr0, len0, ptr1, len1);
    }
    /**
    * @param {ProgramLink} program_link
    */
    addProgramLink(program_link) {
        _assertClass(program_link, ProgramLink);
        var ptr0 = program_link.ptr;
        program_link.ptr = 0;
        wasm.rendererdatabuilder_addProgramLink(this.ptr, ptr0);
    }
    /**
    * @param {RenderCallbackJs} render_callback
    */
    setRenderCallback(render_callback) {
        wasm.rendererdatabuilder_setRenderCallback(this.ptr, addHeapObject(render_callback));
    }
    /**
    * @param {object} ctx
    */
    setUserCtx(ctx) {
        wasm.rendererdatabuilder_setUserCtx(this.ptr, addHeapObject(ctx));
    }
    /**
    * @param {UniformLink} uniform_link
    */
    addUniformLink(uniform_link) {
        _assertClass(uniform_link, UniformLink);
        var ptr0 = uniform_link.ptr;
        uniform_link.ptr = 0;
        wasm.rendererdatabuilder_addUniformLink(this.ptr, ptr0);
    }
    /**
    * @param {BufferLink} buffer_link
    */
    addBufferLink(buffer_link) {
        _assertClass(buffer_link, BufferLink);
        var ptr0 = buffer_link.ptr;
        buffer_link.ptr = 0;
        wasm.rendererdatabuilder_addBufferLink(this.ptr, ptr0);
    }
    /**
    * @param {AttributeLink} attribute_link
    */
    addAttributeLink(attribute_link) {
        _assertClass(attribute_link, AttributeLink);
        var ptr0 = attribute_link.ptr;
        attribute_link.ptr = 0;
        wasm.rendererdatabuilder_addAttributeLink(this.ptr, ptr0);
    }
    /**
    * @param {TextureLink} texture_link
    */
    addTextureLink(texture_link) {
        _assertClass(texture_link, TextureLink);
        var ptr0 = texture_link.ptr;
        texture_link.ptr = 0;
        wasm.rendererdatabuilder_addTextureLink(this.ptr, ptr0);
    }
    /**
    * @param {FramebufferLink} framebuffer_link
    */
    addFramebufferLink(framebuffer_link) {
        _assertClass(framebuffer_link, FramebufferLink);
        var ptr0 = framebuffer_link.ptr;
        framebuffer_link.ptr = 0;
        wasm.rendererdatabuilder_addFramebufferLink(this.ptr, ptr0);
    }
    /**
    * @param {TransformFeedbackLink} transform_feedback_link
    */
    addTransformFeedbackLink(transform_feedback_link) {
        const ptr = this.__destroy_into_raw();
        _assertClass(transform_feedback_link, TransformFeedbackLink);
        var ptr0 = transform_feedback_link.ptr;
        transform_feedback_link.ptr = 0;
        wasm.rendererdatabuilder_addTransformFeedbackLink(ptr, ptr0);
    }
    /**
    * @param {string} vertex_array_object_id
    */
    addVAOLink(vertex_array_object_id) {
        const ptr0 = passStringToWasm0(vertex_array_object_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.rendererdatabuilder_addVAOLink(this.ptr, ptr0, len0);
    }
    /**
    * @param {Function} get_context_callback
    */
    setGetContextCallback(get_context_callback) {
        wasm.rendererdatabuilder_setGetContextCallback(this.ptr, addHeapObject(get_context_callback));
    }
    /**
    * @returns {RendererData}
    */
    buildRendererData() {
        try {
            const ptr = this.__destroy_into_raw();
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rendererdatabuilder_buildRendererData(retptr, ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            var r2 = getInt32Memory0()[retptr / 4 + 2];
            if (r2) {
                throw takeObject(r1);
            }
            return RendererData.__wrap(r0);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @returns {Renderer}
    */
    buildRenderer() {
        try {
            const ptr = this.__destroy_into_raw();
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rendererdatabuilder_buildRenderer(retptr, ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            var r2 = getInt32Memory0()[retptr / 4 + 2];
            if (r2) {
                throw takeObject(r1);
            }
            return Renderer.__wrap(r0);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
}
/**
*/
export class Texture {

    static __wrap(ptr) {
        const obj = Object.create(Texture.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_texture_free(ptr);
    }
    /**
    * @returns {string}
    */
    textureId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {WebGLTexture}
    */
    webglTexture() {
        const ret = wasm.buffer_webglBuffer(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class TextureCreateContext {

    static __wrap(ptr) {
        const obj = Object.create(TextureCreateContext.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_texturecreatecontext_free(ptr);
    }
    /**
    * @returns {WebGL2RenderingContext}
    */
    gl() {
        const ret = wasm.attributecreatecontext_gl(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {number}
    */
    now() {
        const ret = wasm.attributecreatecontext_now(this.ptr);
        return ret;
    }
    /**
    * @returns {HTMLCanvasElement}
    */
    canvas() {
        const ret = wasm.attributecreatecontext_webglBuffer(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class TextureLink {

    static __wrap(ptr) {
        const obj = Object.create(TextureLink.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_texturelink_free(ptr);
    }
    /**
    * @param {string} texture_id
    * @param {TextureCreateCallbackJs} create_texture_callback
    */
    constructor(texture_id, create_texture_callback) {
        const ptr0 = passStringToWasm0(texture_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.bufferlink_new(ptr0, len0, addHeapObject(create_texture_callback));
        return TextureLink.__wrap(ret);
    }
    /**
    * @returns {string}
    */
    textureId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @param {WebGL2RenderingContext} gl
    * @param {number} now
    * @param {HTMLCanvasElement} canvas
    * @returns {WebGLTexture}
    */
    createTexture(gl, now, canvas) {
        const ret = wasm.texturelink_createTexture(this.ptr, addHeapObject(gl), now, addHeapObject(canvas));
        return takeObject(ret);
    }
}
/**
*/
export class TransformFeedbackLink {

    static __wrap(ptr) {
        const obj = Object.create(TransformFeedbackLink.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_transformfeedbacklink_free(ptr);
    }
    /**
    * @param {string} transform_feedback_id
    */
    constructor(transform_feedback_id) {
        const ptr0 = passStringToWasm0(transform_feedback_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.transformfeedbacklink_new(ptr0, len0);
        return TransformFeedbackLink.__wrap(ret);
    }
    /**
    * @returns {string}
    */
    transformFeedbackId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.buffer_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
}
/**
*/
export class Uniform {

    static __wrap(ptr) {
        const obj = Object.create(Uniform.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_uniform_free(ptr);
    }
    /**
    * @returns {StringArray}
    */
    programIds() {
        const ret = wasm.uniform_programIds(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {string}
    */
    uniformId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.uniform_uniformId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {UniformLocationsMap}
    */
    uniformLocations() {
        const ret = wasm.uniform_uniformLocations(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class UniformContext {

    static __wrap(ptr) {
        const obj = Object.create(UniformContext.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_uniformcontext_free(ptr);
    }
    /**
    * @returns {WebGL2RenderingContext}
    */
    gl() {
        const ret = wasm.attributecreatecontext_gl(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {number}
    */
    now() {
        const ret = wasm.attributecreatecontext_now(this.ptr);
        return ret;
    }
    /**
    * @returns {WebGLUniformLocation}
    */
    uniformLocation() {
        const ret = wasm.attributecreatecontext_webglBuffer(this.ptr);
        return takeObject(ret);
    }
}
/**
*/
export class UniformLink {

    static __wrap(ptr) {
        const obj = Object.create(UniformLink.prototype);
        obj.ptr = ptr;

        return obj;
    }

    toJSON() {
        return {
        };
    }

    toString() {
        return JSON.stringify(this);
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_uniformlink_free(ptr);
    }
    /**
    * @param {StringArray} program_ids
    * @param {string} uniform_id
    * @param {UniformCreateUpdateCallbackJs} initialize_callback
    */
    constructor(program_ids, uniform_id, initialize_callback) {
        const ptr0 = passStringToWasm0(uniform_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.uniformlink_new(addHeapObject(program_ids), ptr0, len0, addHeapObject(initialize_callback));
        return UniformLink.__wrap(ret);
    }
    /**
    * @returns {StringArray}
    */
    programIds() {
        const ret = wasm.attributelink_VAOIds(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {string}
    */
    uniformId() {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.attribute_bufferId(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(r0, r1);
        }
    }
    /**
    * @returns {UniformCreateUpdateCallbackJs | undefined}
    */
    initializeCallback() {
        const ret = wasm.uniformlink_initializeCallback(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {UniformCreateUpdateCallbackJs} callback
    */
    setInitializeCallback(callback) {
        wasm.uniformlink_setInitializeCallback(this.ptr, addHeapObject(callback));
    }
    /**
    * @returns {UniformShouldUpdateCallbackJs | undefined}
    */
    shouldUpdateCallback() {
        const ret = wasm.uniformlink_shouldUpdateCallback(this.ptr);
        return takeObject(ret);
    }
    /**
    * @param {UniformShouldUpdateCallbackJs} callback
    */
    setShouldUpdateCallback(callback) {
        wasm.uniformlink_setShouldUpdateCallback(this.ptr, addHeapObject(callback));
    }
    /**
    * @param {UniformCreateUpdateCallbackJs} callback
    */
    setUpdateCallback(callback) {
        wasm.uniformlink_setUpdateCallback(this.ptr, addHeapObject(callback));
    }
    /**
    * @returns {UniformCreateUpdateCallbackJs | undefined}
    */
    updateCallback() {
        const ret = wasm.uniformlink_updateCallback(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {boolean}
    */
    useInitCallbackForUpdate() {
        const ret = wasm.uniformlink_useInitCallbackForUpdate(this.ptr);
        return ret !== 0;
    }
    /**
    * @param {boolean} use_init_callback_for_update
    */
    setUseInitCallbackForUpdate(use_init_callback_for_update) {
        wasm.uniformlink_setUseInitCallbackForUpdate(this.ptr, use_init_callback_for_update);
    }
}

export function __wbindgen_object_drop_ref(arg0) {
    takeObject(arg0);
};

export function __wbindgen_cb_drop(arg0) {
    const obj = takeObject(arg0).original;
    if (obj.cnt-- == 1) {
        obj.a = 0;
        return true;
    }
    const ret = false;
    return ret;
};

export function __wbindgen_object_clone_ref(arg0) {
    const ret = getObject(arg0);
    return addHeapObject(ret);
};

export function __wbg_attributecreatecontext_new(arg0) {
    const ret = AttributeCreateContext.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbg_buffer_new(arg0) {
    const ret = Buffer.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbg_buffercreatecontext_new(arg0) {
    const ret = BufferCreateContext.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbg_uniformcontext_new(arg0) {
    const ret = UniformContext.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbg_framebuffercreatecontext_new(arg0) {
    const ret = FramebufferCreateContext.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbindgen_boolean_get(arg0) {
    const v = getObject(arg0);
    const ret = typeof(v) === 'boolean' ? (v ? 1 : 0) : 2;
    return ret;
};

export function __wbg_rendererdata_new(arg0) {
    const ret = RendererData.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbindgen_json_parse(arg0, arg1) {
    const ret = JSON.parse(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
};

export function __wbg_captureStreamFromCanvas_df4ec62b42ad185d(arg0) {
    const ret = captureStreamFromCanvas(takeObject(arg0));
    return addHeapObject(ret);
};

export function __wbg_texturecreatecontext_new(arg0) {
    const ret = TextureCreateContext.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbindgen_string_new(arg0, arg1) {
    const ret = getStringFromWasm0(arg0, arg1);
    return addHeapObject(ret);
};

export function __wbindgen_is_object(arg0) {
    const val = getObject(arg0);
    const ret = typeof(val) === 'object' && val !== null;
    return ret;
};

export function __wbindgen_string_get(arg0, arg1) {
    const obj = getObject(arg1);
    const ret = typeof(obj) === 'string' ? obj : undefined;
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

export function __wbg_attribute_new(arg0) {
    const ret = Attribute.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbg_uniform_new(arg0) {
    const ret = Uniform.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbg_texture_new(arg0) {
    const ret = Texture.__wrap(arg0);
    return addHeapObject(ret);
};

export function __wbg_randomFillSync_91e2b39becca6147() { return handleError(function (arg0, arg1, arg2) {
    getObject(arg0).randomFillSync(getArrayU8FromWasm0(arg1, arg2));
}, arguments) };

export function __wbg_getRandomValues_b14734aa289bc356() { return handleError(function (arg0, arg1) {
    getObject(arg0).getRandomValues(getObject(arg1));
}, arguments) };

export function __wbg_process_e56fd54cf6319b6c(arg0) {
    const ret = getObject(arg0).process;
    return addHeapObject(ret);
};

export function __wbg_versions_77e21455908dad33(arg0) {
    const ret = getObject(arg0).versions;
    return addHeapObject(ret);
};

export function __wbg_node_0dd25d832e4785d5(arg0) {
    const ret = getObject(arg0).node;
    return addHeapObject(ret);
};

export function __wbindgen_is_string(arg0) {
    const ret = typeof(getObject(arg0)) === 'string';
    return ret;
};

export function __wbg_static_accessor_NODE_MODULE_26b231378c1be7dd() {
    const ret = module;
    return addHeapObject(ret);
};

export function __wbg_require_0db1598d9ccecb30() { return handleError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).require(getStringFromWasm0(arg1, arg2));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_crypto_b95d7173266618a9(arg0) {
    const ret = getObject(arg0).crypto;
    return addHeapObject(ret);
};

export function __wbg_msCrypto_5a86d77a66230f81(arg0) {
    const ret = getObject(arg0).msCrypto;
    return addHeapObject(ret);
};

export function __wbindgen_number_new(arg0) {
    const ret = arg0;
    return addHeapObject(ret);
};

export function __wbg_instanceof_Window_42f092928baaee84(arg0) {
    const ret = getObject(arg0) instanceof Window;
    return ret;
};

export function __wbg_newwithbuffersourcesequenceandoptions_b0af66e333249315() { return handleError(function (arg0, arg1) {
    const ret = new Blob(getObject(arg0), getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_arrayBuffer_d4002abd6619499e(arg0) {
    const ret = getObject(arg0).arrayBuffer();
    return addHeapObject(ret);
};

export function __wbg_data_f3a63e7da5cca52c(arg0) {
    const ret = getObject(arg0).data;
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_setcssText_81cd1b7e42917d2b(arg0, arg1, arg2) {
    getObject(arg0).cssText = getStringFromWasm0(arg1, arg2);
};

export function __wbg_body_5e6efc7a3c1b65f3(arg0) {
    const ret = getObject(arg0).body;
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_createElement_28fc3740fb11defb() { return handleError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).createElement(getStringFromWasm0(arg1, arg2));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_addEventListener_b2c53f6c8c23bac8() { return handleError(function (arg0, arg1, arg2, arg3) {
    getObject(arg0).addEventListener(getStringFromWasm0(arg1, arg2), getObject(arg3));
}, arguments) };

export function __wbg_removeEventListener_f9b9f76b2053cf11() { return handleError(function (arg0, arg1, arg2, arg3) {
    getObject(arg0).removeEventListener(getStringFromWasm0(arg1, arg2), getObject(arg3));
}, arguments) };

export function __wbg_instanceof_HtmlAnchorElement_c5af6ac1bb327b75(arg0) {
    const ret = getObject(arg0) instanceof HTMLAnchorElement;
    return ret;
};

export function __wbg_setdownload_1f8cd4d4e08ffe27(arg0, arg1, arg2) {
    getObject(arg0).download = getStringFromWasm0(arg1, arg2);
};

export function __wbg_sethref_c44a483657f34aff(arg0, arg1, arg2) {
    getObject(arg0).href = getStringFromWasm0(arg1, arg2);
};

export function __wbg_getContext_efe7e95b72348104() { return handleError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).getContext(getStringFromWasm0(arg1, arg2));
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
}, arguments) };

export function __wbg_toDataURL_3d96da630ed7340b() { return handleError(function (arg0, arg1) {
    const ret = getObject(arg1).toDataURL();
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

export function __wbg_style_365767989176e8d2(arg0) {
    const ret = getObject(arg0).style;
    return addHeapObject(ret);
};

export function __wbg_click_48a3ccbed9faabd9(arg0) {
    getObject(arg0).click();
};

export function __wbg_mimeType_a5e973a5cda9a55a(arg0, arg1) {
    const ret = getObject(arg1).mimeType;
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

export function __wbg_newwithmediastreamandmediarecorderoptions_8c2acf39b9c7863b() { return handleError(function (arg0, arg1) {
    const ret = new MediaRecorder(getObject(arg0), getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_isTypeSupported_92fbbd06d513bde6(arg0, arg1) {
    const ret = MediaRecorder.isTypeSupported(getStringFromWasm0(arg0, arg1));
    return ret;
};

export function __wbg_start_0c07b0df18c54194() { return handleError(function (arg0, arg1) {
    getObject(arg0).start(arg1);
}, arguments) };

export function __wbg_stop_6060df0bb8ac0231() { return handleError(function (arg0) {
    getObject(arg0).stop();
}, arguments) };

export function __wbg_appendChild_d21bac021b5bbfde() { return handleError(function (arg0, arg1) {
    const ret = getObject(arg0).appendChild(getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_removeChild_94b0c126b878241b() { return handleError(function (arg0, arg1) {
    const ret = getObject(arg0).removeChild(getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_now_c2563c77371d3ec4(arg0) {
    const ret = getObject(arg0).now();
    return ret;
};

export function __wbg_createObjectURL_7ae06eedcd39cc97() { return handleError(function (arg0, arg1) {
    const ret = URL.createObjectURL(getObject(arg1));
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

export function __wbg_revokeObjectURL_31cc6baf38f77fbe() { return handleError(function (arg0, arg1) {
    URL.revokeObjectURL(getStringFromWasm0(arg0, arg1));
}, arguments) };

export function __wbg_instanceof_WebGl2RenderingContext_d76863c237fc08d8(arg0) {
    const ret = getObject(arg0) instanceof WebGL2RenderingContext;
    return ret;
};

export function __wbg_bindVertexArray_e286fd9529ad575e(arg0, arg1) {
    getObject(arg0).bindVertexArray(getObject(arg1));
};

export function __wbg_createTransformFeedback_6aa067978a3e989f(arg0) {
    const ret = getObject(arg0).createTransformFeedback();
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_createVertexArray_dc39e314b7c3ef4b(arg0) {
    const ret = getObject(arg0).createVertexArray();
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_transformFeedbackVaryings_3b4ab745aebd202d(arg0, arg1, arg2, arg3) {
    getObject(arg0).transformFeedbackVaryings(getObject(arg1), getObject(arg2), arg3 >>> 0);
};

export function __wbg_attachShader_c82f0696db7f45e4(arg0, arg1, arg2) {
    getObject(arg0).attachShader(getObject(arg1), getObject(arg2));
};

export function __wbg_bindAttribLocation_57a58bc854622265(arg0, arg1, arg2, arg3, arg4) {
    getObject(arg0).bindAttribLocation(getObject(arg1), arg2 >>> 0, getStringFromWasm0(arg3, arg4));
};

export function __wbg_bindBuffer_6b1023547fd79019(arg0, arg1, arg2) {
    getObject(arg0).bindBuffer(arg1 >>> 0, getObject(arg2));
};

export function __wbg_compileShader_9ef519d440deb293(arg0, arg1) {
    getObject(arg0).compileShader(getObject(arg1));
};

export function __wbg_createProgram_9df7fd700d993bf3(arg0) {
    const ret = getObject(arg0).createProgram();
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_createShader_4d302cde325e840c(arg0, arg1) {
    const ret = getObject(arg0).createShader(arg1 >>> 0);
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_enableVertexAttribArray_6026f3706125cd38(arg0, arg1) {
    getObject(arg0).enableVertexAttribArray(arg1 >>> 0);
};

export function __wbg_getProgramInfoLog_d184caa574305599(arg0, arg1, arg2) {
    const ret = getObject(arg1).getProgramInfoLog(getObject(arg2));
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

export function __wbg_getProgramParameter_2fbb4ed8178889ac(arg0, arg1, arg2) {
    const ret = getObject(arg0).getProgramParameter(getObject(arg1), arg2 >>> 0);
    return addHeapObject(ret);
};

export function __wbg_getShaderInfoLog_8a60728afb5f6565(arg0, arg1, arg2) {
    const ret = getObject(arg1).getShaderInfoLog(getObject(arg2));
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

export function __wbg_getShaderParameter_5559d063d1453318(arg0, arg1, arg2) {
    const ret = getObject(arg0).getShaderParameter(getObject(arg1), arg2 >>> 0);
    return addHeapObject(ret);
};

export function __wbg_getUniformLocation_8159488a872cf133(arg0, arg1, arg2, arg3) {
    const ret = getObject(arg0).getUniformLocation(getObject(arg1), getStringFromWasm0(arg2, arg3));
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_linkProgram_71ffdb00aea0d6f0(arg0, arg1) {
    getObject(arg0).linkProgram(getObject(arg1));
};

export function __wbg_shaderSource_3aaf925adea06239(arg0, arg1, arg2, arg3) {
    getObject(arg0).shaderSource(getObject(arg1), getStringFromWasm0(arg2, arg3));
};

export function __wbg_useProgram_8ccbf4d31e1e419b(arg0, arg1) {
    getObject(arg0).useProgram(getObject(arg1));
};

export function __wbg_instanceof_WebGlBuffer_5e0aa0dd44023f04(arg0) {
    const ret = getObject(arg0) instanceof WebGLBuffer;
    return ret;
};

export function __wbg_instanceof_WebGlFramebuffer_2ada52dd8827b28f(arg0) {
    const ret = getObject(arg0) instanceof WebGLFramebuffer;
    return ret;
};

export function __wbg_instanceof_WebGlTexture_4c04666663e387bf(arg0) {
    const ret = getObject(arg0) instanceof WebGLTexture;
    return ret;
};

export function __wbg_document_15b2e504fb1556d6(arg0) {
    const ret = getObject(arg0).document;
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_performance_6a3706d0a3ba1118(arg0) {
    const ret = getObject(arg0).performance;
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
};

export function __wbg_cancelAnimationFrame_64e2cf7a1100eec3() { return handleError(function (arg0, arg1) {
    getObject(arg0).cancelAnimationFrame(arg1);
}, arguments) };

export function __wbg_requestAnimationFrame_9e5ccef32fec2b99() { return handleError(function (arg0, arg1) {
    const ret = getObject(arg0).requestAnimationFrame(getObject(arg1));
    return ret;
}, arguments) };

export function __wbg_new_ee1a3da85465d621() {
    const ret = new Array();
    return addHeapObject(ret);
};

export function __wbindgen_is_function(arg0) {
    const ret = typeof(getObject(arg0)) === 'function';
    return ret;
};

export function __wbg_newnoargs_971e9a5abe185139(arg0, arg1) {
    const ret = new Function(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
};

export function __wbg_new_ac586205e4424583() {
    const ret = new Map();
    return addHeapObject(ret);
};

export function __wbg_next_726d1c2255989269(arg0) {
    const ret = getObject(arg0).next;
    return addHeapObject(ret);
};

export function __wbg_next_3d0c4cc33e7418c9() { return handleError(function (arg0) {
    const ret = getObject(arg0).next();
    return addHeapObject(ret);
}, arguments) };

export function __wbg_done_e5655b169bb04f60(arg0) {
    const ret = getObject(arg0).done;
    return ret;
};

export function __wbg_value_8f901bca1014f843(arg0) {
    const ret = getObject(arg0).value;
    return addHeapObject(ret);
};

export function __wbg_iterator_22ed2b976832ff0c() {
    const ret = Symbol.iterator;
    return addHeapObject(ret);
};

export function __wbg_get_72332cd2bc57924c() { return handleError(function (arg0, arg1) {
    const ret = Reflect.get(getObject(arg0), getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_call_33d7bcddbbfa394a() { return handleError(function (arg0, arg1) {
    const ret = getObject(arg0).call(getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_new_e6a9fecc2bf26696() {
    const ret = new Object();
    return addHeapObject(ret);
};

export function __wbg_newwithlength_df0e16f0b90b6295(arg0) {
    const ret = new Array(arg0 >>> 0);
    return addHeapObject(ret);
};

export function __wbg_set_64cc39858b2ec3f1(arg0, arg1, arg2) {
    getObject(arg0)[arg1 >>> 0] = takeObject(arg2);
};

export function __wbg_push_0bc7fce4a139a883(arg0, arg1) {
    const ret = getObject(arg0).push(getObject(arg1));
    return ret;
};

export function __wbg_instanceof_ArrayBuffer_02bbeeb60438c785(arg0) {
    const ret = getObject(arg0) instanceof ArrayBuffer;
    return ret;
};

export function __wbg_call_65af9f665ab6ade5() { return handleError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).call(getObject(arg1), getObject(arg2));
    return addHeapObject(ret);
}, arguments) };

export function __wbg_set_a55cff623a9eaa21(arg0, arg1, arg2) {
    const ret = getObject(arg0).set(getObject(arg1), getObject(arg2));
    return addHeapObject(ret);
};

export function __wbg_set_2762e698c2f5b7e0() { return handleError(function (arg0, arg1, arg2) {
    const ret = Reflect.set(getObject(arg0), getObject(arg1), getObject(arg2));
    return ret;
}, arguments) };

export function __wbg_buffer_34f5ec9f8a838ba0(arg0) {
    const ret = getObject(arg0).buffer;
    return addHeapObject(ret);
};

export function __wbg_resolve_0107b3a501450ba0(arg0) {
    const ret = Promise.resolve(getObject(arg0));
    return addHeapObject(ret);
};

export function __wbg_then_18da6e5453572fc8(arg0, arg1) {
    const ret = getObject(arg0).then(getObject(arg1));
    return addHeapObject(ret);
};

export function __wbg_then_e5489f796341454b(arg0, arg1, arg2) {
    const ret = getObject(arg0).then(getObject(arg1), getObject(arg2));
    return addHeapObject(ret);
};

export function __wbg_self_fd00a1ef86d1b2ed() { return handleError(function () {
    const ret = self.self;
    return addHeapObject(ret);
}, arguments) };

export function __wbg_window_6f6e346d8bbd61d7() { return handleError(function () {
    const ret = window.window;
    return addHeapObject(ret);
}, arguments) };

export function __wbg_globalThis_3348936ac49df00a() { return handleError(function () {
    const ret = globalThis.globalThis;
    return addHeapObject(ret);
}, arguments) };

export function __wbg_global_67175caf56f55ca9() { return handleError(function () {
    const ret = global.global;
    return addHeapObject(ret);
}, arguments) };

export function __wbindgen_is_undefined(arg0) {
    const ret = getObject(arg0) === undefined;
    return ret;
};

export function __wbg_newwithbyteoffsetandlength_88fdad741db1b182(arg0, arg1, arg2) {
    const ret = new Uint8Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
    return addHeapObject(ret);
};

export function __wbg_new_cda198d9dbc6d7ea(arg0) {
    const ret = new Uint8Array(getObject(arg0));
    return addHeapObject(ret);
};

export function __wbg_set_1a930cfcda1a8067(arg0, arg1, arg2) {
    getObject(arg0).set(getObject(arg1), arg2 >>> 0);
};

export function __wbg_length_51f19f73d6d9eff3(arg0) {
    const ret = getObject(arg0).length;
    return ret;
};

export function __wbg_newwithlength_66e5530e7079ea1b(arg0) {
    const ret = new Uint8Array(arg0 >>> 0);
    return addHeapObject(ret);
};

export function __wbg_subarray_270ff8dd5582c1ac(arg0, arg1, arg2) {
    const ret = getObject(arg0).subarray(arg1 >>> 0, arg2 >>> 0);
    return addHeapObject(ret);
};

export function __wbindgen_debug_string(arg0, arg1) {
    const ret = debugString(getObject(arg1));
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

export function __wbindgen_throw(arg0, arg1) {
    throw new Error(getStringFromWasm0(arg0, arg1));
};

export function __wbindgen_memory() {
    const ret = wasm.memory;
    return addHeapObject(ret);
};

export function __wbindgen_closure_wrapper126(arg0, arg1, arg2) {
    const ret = makeClosure(arg0, arg1, 3, __wbg_adapter_32);
    return addHeapObject(ret);
};

export function __wbindgen_closure_wrapper128(arg0, arg1, arg2) {
    const ret = makeClosure(arg0, arg1, 3, __wbg_adapter_35);
    return addHeapObject(ret);
};

export function __wbindgen_closure_wrapper130(arg0, arg1, arg2) {
    const ret = makeClosure(arg0, arg1, 3, __wbg_adapter_35);
    return addHeapObject(ret);
};

export function __wbindgen_closure_wrapper132(arg0, arg1, arg2) {
    const ret = makeClosure(arg0, arg1, 3, __wbg_adapter_35);
    return addHeapObject(ret);
};

export function __wbindgen_closure_wrapper587(arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 66, __wbg_adapter_42);
    return addHeapObject(ret);
};

